## fasttext 0.9.2

=== CMakeLists.txt ===
#
# Copyright (c) 2016-present, Facebook, Inc.
# All rights reserved.
#
# This source code is licensed under the MIT license found in the
# LICENSE file in the root directory of this source tree.
#

cmake_minimum_required(VERSION 2.8.9)
project(fasttext)

# The version number.
set (fasttext_VERSION_MAJOR 0)
set (fasttext_VERSION_MINOR 1)

include_directories(fasttext)

set(CMAKE_CXX_FLAGS " -pthread -std=c++11 -funroll-loops -O3 -march=native")

set(HEADER_FILES
    src/args.h
    src/autotune.h
    src/densematrix.h
    src/dictionary.h
    src/fasttext.h
    src/loss.h
    src/matrix.h
    src/meter.h
    src/model.h
    src/productquantizer.h
    src/quantmatrix.h
    src/real.h
    src/utils.h
    src/vector.h)

set(SOURCE_FILES
    src/args.cc
    src/autotune.cc
    src/densematrix.cc
    src/dictionary.cc
    src/fasttext.cc
    src/loss.cc
    src/main.cc
    src/matrix.cc
    src/meter.cc
    src/model.cc
    src/productquantizer.cc
    src/quantmatrix.cc
    src/utils.cc
    src/vector.cc)


if (NOT MSVC)
  include(GNUInstallDirs)
  configure_file("fasttext.pc.in" "fasttext.pc" @ONLY)
  install(FILES "${CMAKE_BINARY_DIR}/fasttext.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif()

add_library(fasttext-shared SHARED ${SOURCE_FILES} ${HEADER_FILES})
add_library(fasttext-static STATIC ${SOURCE_FILES} ${HEADER_FILES})
add_library(fasttext-static_pic STATIC ${SOURCE_FILES} ${HEADER_FILES})
set_target_properties(fasttext-shared PROPERTIES OUTPUT_NAME fasttext
  SOVERSION "${fasttext_VERSION_MAJOR}")
set_target_properties(fasttext-static PROPERTIES OUTPUT_NAME fasttext)
set_target_properties(fasttext-static_pic PROPERTIES OUTPUT_NAME fasttext_pic
  POSITION_INDEPENDENT_CODE True)
add_executable(fasttext-bin src/main.cc)
target_link_libraries(fasttext-bin pthread fasttext-static)
set_target_properties(fasttext-bin PROPERTIES PUBLIC_HEADER "${HEADER_FILES}" OUTPUT_NAME fasttext)
install (TARGETS fasttext-shared
    LIBRARY DESTINATION lib)
install (TARGETS fasttext-static
    ARCHIVE DESTINATION lib)
install (TARGETS fasttext-static_pic
    ARCHIVE DESTINATION lib)
install (TARGETS fasttext-bin
    RUNTIME DESTINATION bin
 PUBLIC_HEADER DESTINATION include/fasttext)

=== debian/changelog ===
fasttext (0.9.2-3) unstable; urgency=medium

  * debian/patches/build-python-modules-using-shared-library.patch
    - Fix FTBFS on hurd-i386.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 26 Sep 2020 19:41:39 +0900

fasttext (0.9.2-2) unstable; urgency=medium

  * Refresh patch files with Gbp-Pq:
  * debian/patches/explicitly-link-libatomic.patch
    - Fix undefined reference to __atomic_xxx (armel,mipsel,m68k,powerpc,sh4)

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 12 Sep 2020 22:00:40 +0900

fasttext (0.9.2-1) unstable; urgency=medium

  * New upstream version 0.9.2 (Closes: #941628)

  [ TSUCHIYA Masatoshi ]
  * Initial packaging tasks.
  * debian/0001-Support-shared-libraries-and-multiarch.patch
    - Support shared libraries, multiarch.
  * debian/patches/0002-build-python-modules-using-shared-library.patch
    - Support to build python modules

  [ Kentaro Hayashi ]
  * debian/watch
    - Add missing watch file
  * debian/control
    - Bump compatibility level to 13.
    - Bump Standard-Version to 4.5.0.
    - Follow Debian Science Team policy.
    - Add missing Vcs-* fields.
    - Drop python 2 support.
  * debian/copyright
    - Update to latest copyright.
  * debian/source/lintian-overrides
    - Override false positive lintian error about missing-source.
  * debian/missing-source/*
    - Add missing minified JavaScript source file.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 17 May 2020 09:26:35 +0900

=== debian/control ===
Source: fasttext
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 TSUCHIYA Masatoshi <tsuchiya@imc.tut.ac.jp>,
 Kentaro Hayashi <kenhys@xdump.org>
Build-Depends: debhelper-compat (= 13),
	dh-python,
	python3-all-dev,
	python3-numpy,
	python3-pybind11 (>= 2.2.4),
	python3-setuptools,
	quilt,
	cmake,
	xsltproc,
	docbook-xsl
Standards-Version: 4.5.0
Homepage: https://github.com/facebookresearch/fastText
Vcs-Browser: https://salsa.debian.org/science-team/fasttext
Vcs-Git: https://salsa.debian.org/science-team/fasttext.git
Rules-Requires-Root: no

Package: fasttext
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Efficient learning of word representations and sentence classification library
 fastText is a library for efficient learning of word representations
 and sentence classification, which refers subword information to
 enrich word vectors.

Package: libfasttext0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library files of fastText
 fastText is a library for efficient learning of word representations
 and sentence classification, which refers subword information to
 enrich word vectors.
 This package contains runtime library files.

Package: libfasttext-dev
Section: libdevel
Architecture: any
Depends: libfasttext0 (= ${binary:Version}), ${misc:Depends}
Description: Header files of fastText
 fastText is a library for efficient learning of word representations
 and sentence classification, which refers subword information to
 enrich word vectors.
 This package contains header files for development.

Package: python3-fasttext
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Description: fastText binding for Python3
 fastText is a library for efficient learning of word representations
 and sentence classification, which refers subword information to
 enrich word vectors.
 .
 python3-fasttext is its binding for Python3.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure: fasttext.1
	dh_auto_configure --buildsystem=cmake
	dh_auto_configure --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
	dh_auto_build --buildsystem=pybuild

override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	dh_auto_install --buildsystem=pybuild
	find $(CURDIR)/debian/tmp -name '*.a' -print0 | xargs -0 rm -f {}\;

override_dh_auto_clean:
	dh_auto_clean --buildsystem=cmake
	-rm -rf fasttext.1
	-rm -rf .pybuild
	-rm -rf python/fasttext_module/fasttext.egg-info
	-rm -rf build
	-rm -rf tmp

DB2MAN = /usr/share/sgml/docbook/stylesheet/xsl/docbook-xsl/manpages/docbook.xsl
XP     = xsltproc -''-nonet -''-param man.charmap.use.subset "0"

fasttext.1: debian/fasttext.xml
	$(XP) $(DB2MAN) $<

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%fasttext-$1.tar.xz%" \
   https://github.com/facebookresearch/fastText/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## fasttext 0.9.2%2Bds

=== debian/changelog ===
fasttext (0.9.2+ds-8build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:16:01 +0000

fasttext (0.9.2+ds-8) unstable; urgency=medium

  * Team upload.
  * Do not generate a spurious dependency on python3-pkg-resources
    (Closes: #1083386)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 18 Jan 2025 16:42:46 +0100

fasttext (0.9.2+ds-7) unstable; urgency=medium

  * debian/patches/build-python-modules-using-shared-library.patch
    - Fix import error on armel again. (Closes: #1052037)

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 28 Dec 2023 23:07:06 +0900

fasttext (0.9.2+ds-6) unstable; urgency=medium

  [ Bastian Germann ]
  * Drop unnecessary B-D quilt

  [ Kentaro Hayashi ]
  * debian/patches/explicitly-link-libatomic.patch
    - Fix import error on armel (Closes: #1052037)

 -- Kentaro Hayashi <kenhys@xdump.org>  Tue, 26 Dec 2023 22:09:23 +0900

fasttext (0.9.2+ds-5) unstable; urgency=medium

  * Team upload
  * Link with libatomic on armel (Closes: #1052037)

 -- Bastian Germann <bage@debian.org>  Wed, 04 Oct 2023 17:39:12 +0200

fasttext (0.9.2+ds-4) unstable; urgency=medium

  * debian/tests/testsuite
    - Fix autopkgtest regression on armel.

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 23 Jun 2023 19:19:36 +0900

fasttext (0.9.2+ds-3) unstable; urgency=medium

  * debian/tests/control
    - Allow logging to stderr for autopkgtest.

 -- Kentaro Hayashi <kenhys@xdump.org>  Tue, 20 Jun 2023 20:03:50 +0900

fasttext (0.9.2+ds-2) unstable; urgency=medium

  * debian/patches/fix-ftbfs-gcc13.patch
    - Fix FTBFS with GCC-13. (Closes: #1037647)
  * debian/tests
    - Add missing autopkgtest (Closes: #1035197)
  * debian/control
    - Bump Standards-Version to 4.6.2. No other changes are required.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 18 Jun 2023 16:37:00 +0900

fasttext (0.9.2+ds-1) unstable; urgency=medium

  * debian/copyright
    - Remove auto-generated website/static/docs/en/html
      with Files-Excluded.
  * debian/watch
    - Apply repack,repacksuffix option to generate archive.
  * debian/control
    - Revert target architectures restriction.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 27 Nov 2022 21:23:53 +0900

fasttext (0.9.2-4) unstable; urgency=medium

  [ Debian Janitor ]
  * debian/control
    - Remove constraints unnecessary since buster (oldstable)
    - Update standards version to 4.6.1, no changes needed.
    - Apply multi-arch hints.
  * debian/upstream/metadata
    - Set upstream metadata fields: Bug-Database, Bug-Submit,
      Repository-Browse.

  [ Kentaro HAYASHI ]
  * debian/control
    - Update target architectures, Drop kfreebsd-any.

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 17 Nov 2022 22:07:28 +0900

## fasttext 0.9.2+ds

=== Makefile ===
#
# Copyright (c) 2016-present, Facebook, Inc.
# All rights reserved.
#
# This source code is licensed under the MIT license found in the
# LICENSE file in the root directory of this source tree.
#

CXX = c++
CXXFLAGS = -pthread -std=c++11 -march=native
OBJS = args.o autotune.o matrix.o dictionary.o loss.o productquantizer.o densematrix.o quantmatrix.o vector.o model.o utils.o meter.o fasttext.o
INCLUDES = -I.

opt: CXXFLAGS += -O3 -funroll-loops -DNDEBUG
opt: fasttext

coverage: CXXFLAGS += -O0 -fno-inline -fprofile-arcs --coverage
coverage: fasttext

debug: CXXFLAGS += -g -O0 -fno-inline
debug: fasttext

wasm: webassembly/fasttext_wasm.js

wasmdebug: export EMCC_DEBUG=1
wasmdebug: webassembly/fasttext_wasm.js


args.o: src/args.cc src/args.h
	$(CXX) $(CXXFLAGS) -c src/args.cc

autotune.o: src/autotune.cc src/autotune.h
	$(CXX) $(CXXFLAGS) -c src/autotune.cc

matrix.o: src/matrix.cc src/matrix.h
	$(CXX) $(CXXFLAGS) -c src/matrix.cc

dictionary.o: src/dictionary.cc src/dictionary.h src/args.h
	$(CXX) $(CXXFLAGS) -c src/dictionary.cc

loss.o: src/loss.cc src/loss.h src/matrix.h src/real.h
	$(CXX) $(CXXFLAGS) -c src/loss.cc

productquantizer.o: src/productquantizer.cc src/productquantizer.h src/utils.h
	$(CXX) $(CXXFLAGS) -c src/productquantizer.cc

densematrix.o: src/densematrix.cc src/densematrix.h src/utils.h src/matrix.h
	$(CXX) $(CXXFLAGS) -c src/densematrix.cc

quantmatrix.o: src/quantmatrix.cc src/quantmatrix.h src/utils.h src/matrix.h
	$(CXX) $(CXXFLAGS) -c src/quantmatrix.cc

vector.o: src/vector.cc src/vector.h src/utils.h
	$(CXX) $(CXXFLAGS) -c src/vector.cc

model.o: src/model.cc src/model.h src/args.h
	$(CXX) $(CXXFLAGS) -c src/model.cc

utils.o: src/utils.cc src/utils.h
	$(CXX) $(CXXFLAGS) -c src/utils.cc

meter.o: src/meter.cc src/meter.h
	$(CXX) $(CXXFLAGS) -c src/meter.cc

fasttext.o: src/fasttext.cc src/*.h
	$(CXX) $(CXXFLAGS) -c src/fasttext.cc

fasttext: $(OBJS) src/fasttext.cc src/main.cc
	$(CXX) $(CXXFLAGS) $(OBJS) src/main.cc -o fasttext

clean:
	rm -rf *.o *.gcno *.gcda fasttext *.bc webassembly/fasttext_wasm.js webassembly/fasttext_wasm.wasm


EMCXX = em++
EMCXXFLAGS = --bind --std=c++11 -s WASM=1 -s ALLOW_MEMORY_GROWTH=1 -s "EXTRA_EXPORTED_RUNTIME_METHODS=['addOnPostRun', 'FS']" -s "DISABLE_EXCEPTION_CATCHING=0" -s "EXCEPTION_DEBUG=1" -s "FORCE_FILESYSTEM=1" -s "MODULARIZE=1" -s "EXPORT_ES6=1" -s 'EXPORT_NAME="FastTextModule"' -Isrc/
EMOBJS = args.bc autotune.bc matrix.bc dictionary.bc loss.bc productquantizer.bc densematrix.bc quantmatrix.bc vector.bc model.bc utils.bc meter.bc fasttext.bc main.bc


main.bc: webassembly/fasttext_wasm.cc
	$(EMCXX) $(EMCXXFLAGS)  webassembly/fasttext_wasm.cc -o main.bc

args.bc: src/args.cc src/args.h
	$(EMCXX) $(EMCXXFLAGS)  src/args.cc -o args.bc

autotune.bc: src/autotune.cc src/autotune.h
	$(EMCXX) $(EMCXXFLAGS)  src/autotune.cc -o autotune.bc

matrix.bc: src/matrix.cc src/matrix.h
	$(EMCXX) $(EMCXXFLAGS) src/matrix.cc -o matrix.bc

dictionary.bc: src/dictionary.cc src/dictionary.h src/args.h
	$(EMCXX) $(EMCXXFLAGS)  src/dictionary.cc -o dictionary.bc

loss.bc: src/loss.cc src/loss.h src/matrix.h src/real.h
	$(EMCXX) $(EMCXXFLAGS) src/loss.cc -o loss.bc

productquantizer.bc: src/productquantizer.cc src/productquantizer.h src/utils.h
	$(EMCXX) $(EMCXXFLAGS)  src/productquantizer.cc -o productquantizer.bc

densematrix.bc: src/densematrix.cc src/densematrix.h src/utils.h src/matrix.h
	$(EMCXX) $(EMCXXFLAGS) src/densematrix.cc -o densematrix.bc

quantmatrix.bc: src/quantmatrix.cc src/quantmatrix.h src/utils.h src/matrix.h
	$(EMCXX) $(EMCXXFLAGS) src/quantmatrix.cc -o quantmatrix.bc

vector.bc: src/vector.cc src/vector.h src/utils.h
	$(EMCXX) $(EMCXXFLAGS)  src/vector.cc -o vector.bc

model.bc: src/model.cc src/model.h src/args.h
	$(EMCXX) $(EMCXXFLAGS)  src/model.cc -o model.bc

utils.bc: src/utils.cc src/utils.h
	$(EMCXX) $(EMCXXFLAGS)  src/utils.cc -o utils.bc

meter.bc: src/meter.cc src/meter.h
	$(EMCXX) $(EMCXXFLAGS)  src/meter.cc -o meter.bc

fasttext.bc: src/fasttext.cc src/*.h
	$(EMCXX) $(EMCXXFLAGS)  src/fasttext.cc -o fasttext.bc

webassembly/fasttext_wasm.js: $(EMOBJS) webassembly/fasttext_wasm.cc Makefile
	$(EMCXX) $(EMCXXFLAGS) $(EMOBJS) -o webassembly/fasttext_wasm.js

=== debian/changelog ===
fasttext (0.9.2+ds-9) unstable; urgency=medium

  * debian/watch
    - Update d/watch 5
  * debian/control
    - Bump Standards-Version to 4.7.2. no changes required.
  * debian/patches/fix-ftbfs-cmake4.patch
    - Add patch to fix ftbfs with CMake 4 (Closes: #1112883)

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 04 Sep 2025 20:57:08 +0900

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,15 @@
  TSUCHIYA Masatoshi <tsuchiya@imc.tut.ac.jp>,
  Kentaro Hayashi <kenhys@xdump.org>
 Build-Depends: debhelper-compat (= 13),
-	dh-python,
+	dh-sequence-python3,
 	python3-all-dev,
 	python3-numpy,
-	python3-pybind11 (>= 2.2.4),
+	python3-pybind11,
 	python3-setuptools,
-	quilt,
 	cmake,
 	xsltproc,
 	docbook-xsl
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/facebookresearch/fastText
 Vcs-Browser: https://salsa.debian.org/science-team/fasttext
 Vcs-Git: https://salsa.debian.org/science-team/fasttext.git
@@ -33,6 +32,7 @@
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
 Description: Library files of fastText
  fastText is a library for efficient learning of word representations
  and sentence classification, which refers subword information to

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,11 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+include /usr/share/dpkg/architecture.mk
+
+ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
+export DEB_LDFLAGS_MAINT_APPEND = -latomic
+endif
 
 # see ENVIRONMENT in dpkg-buildflags(1)
 # package maintainers to append CFLAGS
@@ -14,7 +19,7 @@
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --with python3 --buildsystem=cmake
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure: fasttext.1
 	dh_auto_configure --buildsystem=cmake

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: auto
Owner: facebookresearch
Project: fastText
Repack: yes
Repacksuffix: +ds
Update-Script: uupdate
